<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Brice Person
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php
class rememberFilter extends sfFilter
{
  public function execute ($filterChain)
  {
    // execute le filtre une seule fois
    if ($this->isFirstCall())
    {
      if ($this->getContext()->getRequest()->getCookie('remember'))
      {
        $context = $this->getContext();
        $remember_cookie = $context->getRequest()->getCookie('remember');
        $secret_key = sfConfig::get('app_secret_key');
        $part = explode("_", $remember_cookie);
        if (sha1($secret_key.$part[0]) == $part[1])
        {
          $user = Doctrine::getTable('Citoyen')->findOneBySlug($part[0]);
          // signin
          $context->getUser()->setAttribute('user_id', $user->getId());
          $context->getUser()->setAttribute('is_active', $user->getIsActive());
          $context->getUser()->setAttribute('login', $user->getLogin());
          $context->getUser()->setAttribute('slug', $user->getSlug());
          $context->getUser()->setAuthenticated(true);
          $context->getUser()->clearCredentials();
          $context->getUser()->addCredentials($user->getRole());
          
          // save last login
          $user->setLastLogin(date('Y-m-d H:i:s'));
          $user->save();
        }
      }
    }
    // execute le prochain
    $filterChain->execute();
  }
}
?>