<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Tangui Morlier, Brice Person
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php

class commentaireComponents extends sfComponents
{
  public function executeForm() {
    /* Respect du hack de l'action */
    $_GET['isAuthenticated'] = 1;
    if (!isset($this->form))
      $this->form = new CommentaireForm();
    
    if (isset($this->object)) {
      $this->id = $this->object->id;
      $this->type = get_class($this->object);
    }
    $this->unique_form = md5(rand());
    $this->getUser()->setAttribute('commentaire_'.$this->type.'_'.$this->id, $this->unique_form);
  }

  public function executeShow() {
    $id = $this->object->id;
    $type = get_class($this->object);
    $this->commentaires = Doctrine::getTable('Commentaire')->createQuery()
      ->where('(object_type = ? AND object_id = ?)', array($type, $id))
      ->execute();
  }
  
  public function executeShowcitoyen() {
    $id = $this->id;
    $this->commentaires = Doctrine::getTable('Commentaire')->createQuery()
      ->where('citoyen_id = ? ', $id)
      ->orderBy('created_at DESC')
      ->execute();
  }
  
  public function executeParlementaire() {
    $this->commentaires = $this->parlementaire->getLastCommentaires();
  }

  public function executePager() {
    if (!$this->query_commentaires)
      throw new Exception('query_commentaires parameter missing');

    $pager = new sfDoctrinePager('Commentaire',20);
    $pager->setQuery($this->query_commentaires);
    $pager->setPage($this->request->getParameter('page', 1));
    $pager->init();

    $this->pager = $pager;
  }
}