<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Tangui Morlier, Benjamin Ooghe, Palkeo
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php

class InterventionComponents extends sfComponents
{
  public function executeParlementaireIntervention()
  {
  }
  public function executeParlementaireQuestion()
  {
    $this->questions = doctrine::getTable('Intervention')->createQuery('i')
      ->where('i.parlementaire_id = ?', $this->parlementaire->id)
      ->andWhere('i.type = ?', 'question')
      ->andWhere('i.fonction NOT LIKE ?', 'président%')
      ->andWhere('i.nb_mots > ?', 20)
      ->groupBy('i.seance_id')
      ->orderBy('i.date DESC, i.timestamp ASC')
      ->execute();
  }
  public function executePagerInterventions()
  {
    if (!$this->intervention_query)
          throw new Exception('intervention_query parameter missing');

    $pager = new sfDoctrinePager('Intervention',20);
    $pager->setQuery($this->intervention_query);
    $pager->setPage($this->request->getParameter('page', 1));
    $pager->init();

    $this->pager = $pager;
  }
}
