<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Benjamin Ooghe, Tangui Morlier
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php

/**
 * parlementaire actions.
 *
 * @package    cpc
 * @subpackage parlementaire
 * @author     Benjamin Ooghe, Tangui Morlier
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class presenceActions extends sfActions
{

  public function executeParlementaire(sfWebRequest $request)
  {
    $this->parlementaire = Doctrine::getTable('Parlementaire')->findOneBySlug($request->getParameter('slug'));
    $this->forward404Unless($this->parlementaire);

    $query = Doctrine::getTable('Presence')->createQuery('p');
    $query->where('p.parlementaire_id = ?', $this->parlementaire->id);
    $query->leftJoin('p.Seance.Organisme o')
      ->leftJoin('p.Preuves pr')
      ->orderBy('p.Seance.type ASC, p.Seance.date DESC')
      ->groupBy('p.Seance.id');
    $this->presences = $query->execute();
  }

  public function executePreuve(sfWebRequest $request)
  {
    $this->parlementaire = Doctrine::getTable('Parlementaire')->findOneBySlug($request->getParameter('slug'));
    $this->forward404Unless($this->parlementaire);
    $seance_id = $request->getParameter('seance');
    $this->seance = Doctrine::getTable('Seance')->findOneById($seance_id);
    $this->forward404Unless($this->seance);
    $this->preuves = doctrine::getTable('PreuvePresence')
      ->createQuery('pp')
      ->leftJoin('pp.Presence p')
      ->where('p.seance_id = ?', $seance_id)
      ->andWhere('p.parlementaire_id = ?', $this->parlementaire->id)
      ->execute();
  }

  public function executeSeance(sfWebRequest $request)
  {
    $seance_id = $request->getParameter('seance');
    $this->forward404Unless($seance_id);
    $this->seance = doctrine::getTable('Seance')->createQuery('s')
      ->where('s.id = ?', $seance_id)
      ->leftJoin('s.Organisme')
      ->fetchOne();
    $this->forward404Unless($this->seance);
    $this->presences = doctrine::getTable('Presence')->createQuery('p')
      ->where('p.seance_id = ?', $seance_id)
      ->leftJoin('p.Parlementaire pa')
      ->leftJoin('p.Preuves pr')
      ->groupBy('pa.id')
      ->orderBy('p.nb_preuves DESC, pa.nom_de_famille ASC')
      ->execute();
  }
}
