<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Tangui Morlier, Collectif
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php

/**
 * rate actions.
 *
 * @package    cpc
 * @subpackage rate
 * @author     Tangui Morlier, Collectif
 * @version    SVN: $Id: actions.class.php 12479 2008-10-31 10:54:40Z fabien $
 */
class rateActions extends sfActions
{

  static $rate_conversion = array('0' => 0, '1' => 1, '2' => 2);
 /**
  * Executes index action
  *
  * @param sfRequest $request A request object
  */
  public function executeRateIt(sfWebRequest $request)
  {
    if (!$this->getUser()->isAuthenticated()) {
      $this->getUser()->setFlash('notice', 'Vous devez être identifié pour donner une opinion sur cet élement');
      return $this->redirect($request->getReferer());
    }
    $citoyen_id = $this->getUser()->getAttribute('user_id');
    $note = $request->getParameter('rate');
    $id = $request->getParameter('object_id');
    $type = $request->getParameter('object_type');
    $object = Doctrine::getTable($type)->find($id);
    $this->forward404Unless($object);
    
    $rate = new Rate();
    $rate->rate = self::$rate_conversion[$note];
    $rate->object_type = $object;
    $rate->object_id = $id;
    $rate->citoyen_id = $citoyen_id;
    try {
      $rate->save();
    }catch(Exception $e) {
      $this->getUser()->setFlash('error', 'Vous ne pouvez donner votre avis qu\'une seule fois');
      return $this->redirect($request->getReferer());
    }

    $a = Doctrine_Query::create()
      ->from('Rate')
      ->select('AVG(rate) as rate')
      ->where('object_type = ?', $type)
      ->andWhere('object_id = ?', $id)
      ->fetchArray();

    $object->rate = $a[0]['rate'];
    $object->save();

    $this->getUser()->setFlash('notice', 'Merci ! Votre opinion a bien été prise en compte');
    return $this->redirect($request->getReferer());
  }
}
