<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Tangui Morlier
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php

/**
 * Article form.
 *
 * @package    form
 * @subpackage Article
 * @version    SVN: $Id: sfDoctrineFormTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
class ArticleForm extends BaseArticleForm
{
  public function configure()
  {
    unset($this['created_at'],
	  $this['updated_at'],
	  $this['version'],
	  $this['slug'],
	  $this['link'],
	  $this['citoyen_id'],
	  $this['nb_commentaires'],
	  $this['rate']
	  ) ;
    $this->widgetSchema['categorie'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['corps'] = new sfWidgetFormInputHidden();
    $this->widgetSchema['user_corps']->setOption('label', 'Corps');
    if (!isset($_GET['moderateur']) || !$_GET['moderateur']) {
      unset($this['status']);
    }
  }

  public function setTitre($b)
  {
    if (!$b) {
      $this->widgetSchema['titre'] = new sfWidgetFormInputHidden();
      return ;
    }
    $this->validatorSchema['titre'] = new sfValidatorRegex(array('pattern' => '/^[^\<]+$/', 'required'=>true), array('invalid' => 'tags html non authorisés', 'required' => 'titre obligatoire'));
  }

  public function setObject($b, $categorie, $display = true) {
    if (!$b) {
      unset($this['object_id']);
      return;
    }

    if ($display) {
      $this->widgetSchema['object_id'] = new sfWidgetFormDoctrineChoice(array('model' => $this->getValue('categorie')));
      $this->widgetSchema['object_id']->setOption('label', $categorie);
      $query = doctrine::getTable($categorie)->createQuery('c')->where('c.nom IS NOT NULL')->orderBy('nom');
      $this->widgetSchema['object_id']->setOption('query', $query);
    }else{
      $this->widgetSchema['object_id'] = new sfWidgetFormInputHidden();
    }
    
  }

  public function setUnique($b) {
    if (!$b)
      return;
    $this->validatorSchema->setPostValidator(new sfValidatorDoctrineUnique(array('model' => 'Article', 'column' => array('object_id' ,'categorie')), array('invalid' => 'Il existe déjà un article pour cet objet')));
  }

  public function setParent($b, $categorie) {
    if (!$b) {
      unset($this['article_id']);
      return ;
    }

    $query = doctrine::getTable('Article')->createQuery('a')->where('a.article_id IS NULL')->andWhere('a.categorie = ?', $categorie);
    if ($this->object && $this->object->id) {
      $query->andWhere('a.id != ?', $this->object->id);
    }
    $this->widgetSchema['article_id']->setOption('query', $query);
    $this->widgetSchema['article_id']->setOption('label', 'Article père');
  }
}