<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Tangui Morlier, Brice Person, Gabriel Kerneis
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php

/**
 * Commentaire form.
 *
 * @package    form
 * @subpackage Commentaire
 * @version    SVN: $Id: sfDoctrineFormTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
class CommentaireForm extends BaseCommentaireForm
{
  public function configure()
  {
    unset(
    $this['id'],
    $this['citoyen_id'],
    $this['updated_at'],
    $this['created_at'],
    $this['is_public'],
    $this['ip_address'],
    $this['rate'],
    $this['object_type'],
    $this['lien'],
    $this['presentation'],
    $this['object_id'],
    $this['parlementaires_list']
    );
    $this->validatorSchema['commentaire'] = new sfValidatorString(array('required' => true, 'min_length'=>10), array('required' => 'Ce champ est obligatoire', 'min_length' => 'Le commentaire trop court, il doit faire au moins %min_length% caractères'));
    
    if (!sfContext::getInstance()->getUser()->isAuthenticated() || !$_GET['isAuthenticated']) 
    {
      $this->widgetSchema['nom'] = new sfWidgetFormInput();
      $this->widgetSchema['email'] = new sfWidgetFormInput();
      $this->widgetSchema['login'] = new sfWidgetFormInput();
      $this->widgetSchema['password'] = new sfWidgetFormInputPassword();
      
      
      $this->validatorSchema['nom'] = new sfValidatorString(array('required' => false, 'min_length' => 4, 'max_length' => 40), array('invalid' => 'Ce nom d\'utilisateur existe déjà.', 'min_length' => '"%value%" est trop court (%min_length% caractères minimum).', 'max_length' => '"%value%" est trop long (%max_length% caractères maximum).'));
      $this->validatorSchema['email'] = new sfValidatorEmail(array('required' => false), array('invalid' => 'Adresse email invalide.'));
      $this->validatorSchema['login'] = new sfValidatorString(array('required' => false), array('invalid' => 'Ce nom d\'utilisateur n\'existe pas.'));
      $this->validatorSchema['password'] = new sfValidatorString(array('required' => false), array('invalid' => 'Le mot de passe ne correspond pas.'));
      
    // labels
    $this->widgetSchema->setLabels(array(
      'commentaire' => 'Ecrire un commentaire',
      'nom' => 'Nom d\'utilisateur',
      'email' => 'Email',
      'login' => 'Nom d\'utilisateur ou Email',
      'password' => 'Mot de passe',
    ));
    }
  }
}
