<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Brice Person
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php
class EditUserForm extends CitoyenForm  
{
  public function configure()
  {
    // Enleve les widgets qu'on ne veut pas montrer
    unset(
      $this['id'], 
      $this['login'], 
      $this['password'], 
      $this['email'], 
      $this['photo'], 
      $this['employe_an'], 
      $this['travail_pour'], 
      $this['nom_circo'], 
      $this['num_circo'], 
      $this['is_active'], 
      $this['activation_id'], 
      $this['role'], 
      $this['last_login'], 
      $this['created_at'], 
      $this['updated_at'], 
      $this['slug']
    );
    
    $annees = range(1920, date('Y')); // array des dates depuis 1920
    $liste_annees = array_combine($annees, $annees); // array clés et valeurs des dates
      
    $this->widgetSchema['naissance'] = new sfWidgetFormDate(array('format' => '%day%/%month%/%year%', 'years' => $liste_annees));
    
    $this->widgetSchema['url_site'] = new sfWidgetFormInput();
    $this->validatorSchema['url_site'] = new sfValidatorUrl(array('required' => false), array('invalid' => 'l\'url doit être de la forme "http://www.monsite.fr"'));
    
    // Les labels
    $this->widgetSchema->setLabels(array(
      'activite' => 'Activité : ', 
      'url_site' => 'Site web : ', 
      'naissance' => 'Date de naissance : ', 
      'sexe' => 'Civilité : '
    ));
  }
  
}
?>