<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Brice Person
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php
class InscriptionForm extends sfForm
{
  public function configure()
  {
    $this->widgetSchema->setNameFormat('citoyen[%s]');
    
    #$this->widgetSchema->setOption('form_formatter', 'list');  'unique_error' => '"%value%" existe déjà', 
    
    $this->widgetSchema['login'] = new sfWidgetFormInput();
    $this->validatorSchema['login'] = new sfValidatorString(array('required' => true, 'min_length' => 4, 'max_length' => 40), array('invalid' => 'Ce nom d\'utilisateur existe déjà.',
    'required' => 'Indiquez le nom d\'utilisateur souhaité', 
    'min_length' => '"%value%" est trop court (%min_length% caractères minimum).', 
    'max_length' => '"%value%" est trop long (%max_length% caractères maximum).'));
    
    $this->widgetSchema['email'] = new sfWidgetFormInput();
    $this->validatorSchema['email'] = new sfValidatorEmail(array('required' => true), array('invalid' => 'Adresse email invalide.', 'required' => 'Indiquez votre adresse email', ));
    
    // Les labels
    $this->widgetSchema->setLabels(array(
      'login' => 'Nom d\'utilisateur',
      'email' => 'Email'
    ));
    
  }
}
?>