<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Brice Person
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php
class SigninForm extends sfForm
{
  public function configure()
  {
    $this->setWidgets(array(
      'login' => new sfWidgetFormInput(),
      'password' => new sfWidgetFormInputPassword(),
      'remember' => new sfWidgetFormInputCheckbox()
    ));
    
    $this->widgetSchema->setNameFormat('signin[%s]');
    
    $this->setValidators(array(
      'login' => new sfValidatorString(array('required' => true), array('invalid' => 'Ce nom d\'utilisateur n\'existe pas.', 'required' => 'Veuillez indiquer votre nom d\'utilisateur.')),
      'password'  => new sfValidatorString(array('required' => true), array('invalid' => 'Le mot de passe ne correspond pas.', 'required' => 'Veuillez indiquer votre mot de passe.')),
      'remember'  => new sfValidatorBoolean(array('required' => false))
    ));   

    // labels
    $this->widgetSchema->setLabels(array(
      'login' => 'Nom d\'utilisateur ou Email : ', 
      'password' => 'Mot de passe : ', 
      'remember' => 'Se rappeler de moi : '
    ));
  }
}
?>