<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Tangui Morlier, Benjamin Ooghe
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class Intervention extends BaseIntervention
{
  public function getLink() {
    return '@intervention?id='.$this->id;
  }

  public function __toString() {
    return strip_tags($this->intervention);
  }

  public function getTitre() {
    $titre = 'Intervention du '.$this->date.' ';
    if ($this->type == 'commission') {
      $titre .= 'en commission';
    }else{
      $titre .= 'en hémicycle';
    }
    return $titre;
  }

  public function setSeance($type, $date, $heure, $session, $commission = null) {
    $this->setType($type);
    if ($type == 'commission') {
      $commission = Doctrine::getTable('Organisme')->findOneByNomOrCreateIt($commission, 'parlementaire');
      $seance = $commission->getSeanceByDateAndMomentOrCreateIt($date, $heure, $session);
      $commission->free();
    } else{
      $seance = Doctrine::getTable('Seance')->findOneOrCreateIt('hemicycle', $date, $heure, $session);
    }
    $id = $this->_set('seance_id', $seance->id);
    $seance->free();
    return $id;
  }
  public function setPersonnaliteByNom($nom, $fonction = null) 
  {
    $this->setFonction($fonction);
    if (!preg_match('/ministre|secr[^t]+taire [^t]+tat|commissaire|garde des sceaux/i', $fonction)) { 
      $personne = Doctrine::getTable('Parlementaire')->findOneByNom($nom);
      if (!$personne) {
	$personne = Doctrine::getTable('Parlementaire')->similarTo($nom);
      }
      if ($personne) {
	return $this->setParlementaire($personne);
      }
    }
    $personne = Doctrine::getTable('Personnalite')->findOneByNom($nom);
    if (!$personne) {
      $personne = Doctrine::getTable('Personnalite')->similarTo($nom);
    }
    if (!$personne) {
      $personne = new Personnalite();
      $personne->setNom($nom);
      $personne->save();
    }
    if ($personne) {
      return $this->setPersonnalite($personne,$fonction);
    }
  }
  public function setParlementaire($parlementaire, $from_db = null) {
    if (isset($parlementaire->id)) {
      $this->_set('parlementaire_id', $parlementaire->id);
      if (!$from_db)
        $this->getSeance()->addPresence($parlementaire, 'intervention', $this->source);
    }
    $parlementaire->free();
  }

  public function hasIntervenant() {
    if ($this->parlementaire_id) {
      return true;
    }
    if ($this->personnalite_id) {
      return true;
    }
    return false;
  }

  public function getIntervenant() {
    $perso = $this->Parlementaire;
    if (!$perso->id)
      $perso = $this->Personnalite;
    return $perso;
  }

  public function getNomAndFonction() {
    $res = null;
    if ($this->hasIntervenant()) {
      $res = $this->getIntervenant()->getNom();
      if ($this->getFonction())
	$res .= ', '.$this->getFonction();
    }
    return $res;
  }

  public function setContexte($context, $date = null, $timestamp = null) {
    return $this->setSection(doctrine::getTable('Section')->findOneByContexteOrCreateIt($context, $date, $timestamp));
  }

  public function setAmendements($tamendements) {
    $tamendements = preg_replace('/[^,\d]+/', '', $tamendements);
    $amends = preg_split('/\s*,\s*/', $tamendements);
    foreach($amends as $amend) {
      $tag = 'loi:amendement='.$amend;
      $this->addTag($tag);
      if ($this->Section->section_id && $this->Section->Section->id) {
        $this->Section->Section->addTag($tag);
      }
    }
  }
  public function setLois($tlois) {
    $tlois = preg_replace('/[^,\d]+/', '', $tlois);
    $lois = preg_split('/\s*,\s*/', $tlois);
    foreach($lois as $loi) {
      $tag = 'loi:numero='.$loi;
      $this->addTag($tag);
      $this->Section->addTag($tag);
      if ($this->Section->section_id && $this->Section->Section->id) {
	$this->Section->Section->addTag($tag);
      }
    }
  }
  public function setIntervention($s) {
    $this->_set('nb_mots', str_word_count($s));
    return $this->_set('intervention', $s);
  }

  public function getIntervention($args = array()) {
    $inter = $this->_get('intervention');
    if (isset($args['linkify_amendements']) && $linko = $args['linkify_amendements']) {
      $inter = preg_replace('/\(([^\)]+)\)/', '(<i>\\1</i>)', $inter);
      if (preg_match_all('/(amendements?[,\s]+(identiques?)?[,\s]*)((n[°os\s]*|\d+\s*|,\s*|à\s*|et\s*|rectifié\s*)+)/', $inter, $match)) {
	$lois = implode(',', $this->getTags(array('is_triple' => true,
						  'namespace' => 'loi',
						  'key' => 'numero',
						  'return'    => 'value')));
	for ($i = 0 ; $i < count($match[0]) ; $i++) {
	  $match_protected = preg_replace('/(\s*)(\d[\d\s\à]*rectifiés?|\d[\d\s\à]*)(,\s*|\s*et\s*)*/', '\1%\2%\3', $match[3][$i]);
	  if (preg_match_all('/\s*%([^%]+)%(,\s*|\s*et\s*)*/', $match_protected, $amends)) {
	    $replace = $match_protected;
	    foreach($amends[1] as $amend) {
	      $am = preg_replace('/à+/', '-', $amend);
	      $am = preg_replace('/[^\d\-]+/', '',$am);
	      $link = str_replace('LLL', urlencode($lois), $linko);
	      $link = str_replace('AAA', urlencode($am), $link);
	      $replace = preg_replace('/%'.$amend.'%/', '<a name="amend_'.$am.'" href="'.$link.'">'.$amend.'</a> ', $replace);
	    }
	    $inter = preg_replace('/'.$match[1][$i].$match[3][$i].'/', $match[1][$i].$replace, $inter);
	  }
	}
      }
    }
    return $inter;
  }
}