<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Tangui Morlier, Benjamin Ooghe, Brice Person
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php

require_once "myTools.class.php";

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class Organisme extends BaseOrganisme
{
  public function __tostring() {
    return substr($this->nom, 0, 100);
  }
  public function getSmallNomGroupe() {
    $hashmap = array(
        "Union pour un mouvement populaire" => "UMP",
        "Socialiste, radical, citoyen et divers gauche" => "SRC",
        "Gauche démocrate et républicaine" => "GDR",
        "Députés n'appartenant à aucun groupe" => "NI",
        "Nouveau centre" => "NC"
    );
    return $hashmap[$this->getNom()];
  }

  public function getCouleur() {
    $hashmap = array(
        "Union pour un mouvement populaire" => "30,30,200",
        "Socialiste, radical, citoyen et divers gauche" => "255,50,190",
        "Gauche démocrate et républicaine" => "255,30,30",
        "Députés n'appartenant à aucun groupe" => "200,200,200",
        "Nouveau centre" => "30,190,255"
    );
    return '<span style=\'background-color: rgb('.$hashmap[$this->getNom()].');\'>&nbsp;&nbsp;</span>';
  }
  public static function getNomByAcro($acro) {
    $acro = strtolower($acro);
    if (preg_match('/^(ump|src|gdr|ni|nc)$/i', $acro)) {
      $hashmap = array(
         "ump" => "Union pour un mouvement populaire",
         "src" => "Socialiste, radical, citoyen et divers gauche",
         "gdr" => "Gauche démocrate et républicaine",
         "ni" => "Députés n'appartenant à aucun groupe",
         "nc" => "Nouveau centre" );
      return $hashmap["$acro"];
    } else {
      return false;
    }
  }
  public function getSeanceByDateAndMomentOrCreateIt($date, $moment, $session = null) {
    $seance = $this->getSeanceByDateAndMoment($date, $moment);
    if (!$seance) {
      $seance = new Seance();
      $seance->type = 'commission';
      $seance->setDate($date);
      $seance->moment = Seance::convertMoment($moment);
      $seance->Organisme = $this;
      $seance->setSession($session);
      $seance->save();
    }
    return $seance;
  }

  public function getNom() {
    if ($this->_get('nom') == 'assemblée nationale')
      return "Bureau de l'Assemblée Nationale";
    else return ucfirst($this->_get('nom'));
  }

  public function getSeanceByDateAndMoment($date, $moment) {
    $moment = Seance::convertMoment($moment);
    $q = Doctrine::getTable('Seance')->createQuery('s');
    $q->where("organisme_id = ?", $this->id)->andWhere('date = ?', $date)->andWhere('moment = ?', $moment);
    $res = $q->fetchOne();
    $q->free();
    unset($q);
    if ($res) {
      return $res;
    }
    $q = Doctrine::getTable('Seance')->createQuery('s');
    $q->where("organisme_id = ?", $this->id)->andWhere('date = ?', $date);
    if (count($q->fetchArray()) && preg_match('/(\d+)[:](\d+)/', $moment, $match)) {
      $q = Doctrine::getTable('Seance')->createQuery('s');
      $q->where("organisme_id = ?", $this->id)->andWhere('date = ?', $date)->andWhere('moment LIKE ?', $match[1].':%');
      $res = $q->fetchOne();
      $q->free();
      unset($q);
    }
    return $res;
  }
}