<?php
//////////////////////////////////////////////////////////////
// Copyright (C) 2009 : Tangui Morlier, Benjamin Ooghe
// This file is part of Regards Citoyens' CPC Project.
// The Project is free software: you can redistribute it 
// and/or modify it under the terms of the Affero General
// Public License as published by Free Software Foundation
// either version 3 of the License, or (at your option)
// any later version.

// The Project is distributed in the hope that it will be
// useful, but WITHOUT ANY WARRANTY; without even the 
// implied warranty of MERCHANTABILITY or FITNESS FOR 
// A PARTICULAR PURPOSE. See the Affero General Public
// License for more details.

// You should have received a copy of the Affero General
// Public
// License in the COPYING file that comes with Regards 
// Citoyen's CPC Project.
// If not, see <http://www.gnu.org/licenses/>.
//-----------------------------------------------------------?>
<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class ParlementaireTable extends PersonnaliteTable
{
  public function findOneByNomSexeGroupeCirco($nom, $sexe = null, $groupe = null, $circo = null, $amendement = null) {
    $depute = null;
    $memeNom = $this->findByNom($nom);
    if (count($memeNom) != 1 && ($circo)) {
      $query = $this->createQuery('p')
        ->where('p.nom_de_famille = ?', $nom)
        ->andWhere('p.nom_circo LIKE ?', $circo);
      $memeNom = $query->execute();
    }
    if (count($memeNom) == 0 && ($circo)) {
      $query = $this->createQuery('p')
        ->where('p.nom = ?', $nom)
        ->andWhere('p.nom_circo LIKE ?', $circo);
      $memeNom = $query->execute();
    }
    if (count($memeNom) == 0 && ($circo)) {
      $memeNom = $this->findByNom($circo." ".$nom);
    }
    if (count($memeNom) == 0) {
      $query = $this->createQuery('p')
        ->where('p.nom_de_famille = ?' , $nom);
      if ($amendement) $query->andWhere('p.fin_mandat is null or p.fin_mandat > ?', $amendement->getDate());
      $memeNom = $query->execute();
    }
    if (count($memeNom) == 0 && preg_match('/([A-Z].*) ([A-Z].*)/', $nom, $match)) {
      $revert_nom = $match[2]." ".$match[1];
      $memeNom = $this->findByNom($revert_nom);
    }
    if (count($memeNom) == 0) $depute = $this->similarTo(preg_replace('/^\s*(de |du |la )+\s*/i', '', $nom), $sexe);
    elseif (count($memeNom) == 1) $depute = $memeNom[0];
    else {
      $memeSexe = array();
      if ($sexe) {
        foreach ($memeNom as $de)
          if ($de->sexe == $sexe) array_push($memeSexe, $de);
        if (count($memeSexe) == 1) $depute = $memeSexe[0];
      }
      if (!$depute && $groupe) {
        $memeGroupe = array();
        $procheGroupe = array();
        if (count($memeSexe) == 0) $memeSexe = $memeNom;
        foreach ($memeSexe as $de) {
          $groupe2 = $de->groupe_acronyme;
          if ($groupe2 == $groupe) array_push($memeGroupe, $de);
          elseif (($groupe2 == "UMP" && $groupe == "NC") || ($groupe2 == "NC" && $groupe == "UMP")) array_push($procheGroupe, $de);
          elseif (($groupe2 == "SRC" && $groupe == "GDR") || ($groupe2 == "GDR" && $groupe == "SRC")) array_push($procheGroupe, $de);
        }
        if (count($memeGroupe) == 1) $depute = $memeGroupe[0];
        elseif (count($procheGroupe) == 1) $depute = $procheGroupe[0];
        unset($memeGroupe);
        unset($procheGroupe);
      }
      unset($memeSexe);
    }
    unset($memeNom);
    return $depute;
  }

  public function getPager($request, $query = NULL)
  {
    $pager = new sfDoctrinePager('Parlementaire',30);
    if (!$query) {
      $query = $this->createQuery('p')->orderBy('p.nom_de_famille ASC');
    }
    $pager->setQuery($query);
    $pager->setPage($request->getParameter('page', 1));
    $pager->init();
    return $pager;
  }
}
